Revit二次开发-生成构件的三维剖面框

        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
    {
        UIDocument uidoc = commandData.Application.ActiveUIDocument;
        Document doc = uidoc.Document;
        Selection sel = uidoc.Selection;
        View view = commandData.View;
        Element ele = doc.GetElement(sel.PickObject(ObjectType.Element, "选择构件"));
        BoundingBoxXYZ boundingBox = ele.get_BoundingBox(view);
        Transform transform = Transform.Identity;         

        BoundingBoxXYZ box = new BoundingBoxXYZ();
        box.Transform = transform;
        box.Min = boundingBox.Min;
        box.Max = boundingBox.Max;
        Transaction ts = new Transaction(doc, "创建围框");
        ts.Start();
        View3D view3D = View3D.CreateIsometric
            (doc, new FilteredElementCollector(doc).OfClass(typeof(ViewFamilyType))
            .Cast<ViewFamilyType>().Where(m => m.ViewFamily == ViewFamily.ThreeDimensional)
            .First().Id);
        //设置三维剖面框      
        view3D.SetSectionBox(box);
        ts.Commit();
        if (view3D.ViewType==ViewType.ThreeD)
        {
            uidoc.ActiveView = view3D;
        }   
        //List<View3D> view3D = new FilteredElementCollector(doc).OfClass(typeof(View3D)).Cast<View3D>().Where(m => m.Name == "分析模型").ToList();
        //TaskDialog.Show("1",view3D.Count.ToString());
        //uidoc.ActiveView = view3D[0];
      return Result.Succeeded;
    }
  • 2
    点赞
  • 10
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值